OpenTTD Source: NetworkGameWindow Class Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Data Fields | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes
NetworkGameWindow Class Reference
Inheritance diagram for NetworkGameWindow:

## Public Member Functions
| NetworkGameWindow (WindowDesc &desc)
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnPaint () override
| The window must be repainted.
StringID | GetHeaderString () const
void | DrawDetails (const Rect &r) const
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
EventState | OnKeyPress (char32_t key, uint16_t keycode) override
| A key has been pressed.
void | OnEditboxChanged (WidgetID wid) override
| The text in an editbox has been edited.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
void | OnResize () override
| Called after the window got resized.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | SetStringParameters (WidgetID widget) const
| Initialize string parameters for a widget.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownSelect (WidgetID widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Data Fields
IntervalTimer< TimerWindow > | refresh_interval
| Refresh the online servers on a regular interval.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position

## Protected Member Functions
void | BuildGUINetworkGameList ()
| Dimension of compatibility icon.
void | SortNetworkGameList ()
| Sort the server list.
void | UpdateListPos ()
| Set this->list_pos to match this->server.
void | DrawServerLine (const NetworkGameList *cur_item, int y, bool highlight) const
| Draw a single server line.
void | ScrollToSelectedServer ()
| Scroll the list up or down to the currently selected server.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.

## Static Protected Member Functions
static bool | NGameNameSorter (NetworkGameList *const &a, NetworkGameList *const &b)
| Sort servers by name.
static bool | NGameClientSorter (NetworkGameList *const &a, NetworkGameList *const &b)
| Sort servers by the amount of clients online on a server.
static bool | NGameMapSizeSorter (NetworkGameList *const &a, NetworkGameList *const &b)
| Sort servers by map size.
static bool | NGameCalendarDateSorter (NetworkGameList *const &a, NetworkGameList *const &b)
| Sort servers by calendar date.
static bool | NGameTicksPlayingSorter (NetworkGameList *const &a, NetworkGameList *const &b)
| Sort servers by the number of ticks the game is running.
static bool | NGameAllowedSorter (NetworkGameList *const &a, NetworkGameList *const &b)
| Sort servers by joinability.
static bool | NGameSearchFilter (NetworkGameList *const *item, StringFilter &sf)

## Protected Attributes
NetworkGameList * | server
| Selected server.
NetworkGameList * | last_joined
| The last joined server.
GUIGameServerList | servers
| List with game servers.
ServerListPosition | list_pos
| Position of the selected server.
Scrollbar * | vscroll
| Vertical scrollbar of the list of servers.
QueryString | name_editbox
| Client name editbox.
QueryString | filter_editbox
| Editbox for filter on servers.
bool | searched_internet = false
| Did we ever press "Search Internet" button?
Dimension | lock
Dimension | blot
| Dimension of lock icon.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Static Protected Attributes
static Listing | last_sorting = {false, 5}
static const std::initializer_list< GUIGameServerList::SortFunction *const > | sorter_funcs
static const std::initializer_list< GUIGameServerList::FilterFunction *const > | filter_funcs

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.

## Detailed Description

Definition at line 176 of file network_gui.cpp.

## Constructor & Destructor Documentation

## ◆ NetworkGameWindow()

NetworkGameWindow::NetworkGameWindow | ( | WindowDesc & | desc | ) |
| inline

Definition at line 436 of file network_gui.cpp.

## ◆ ~NetworkGameWindow()

NetworkGameWindow::~NetworkGameWindow | ( |  | ) |
| inline

Definition at line 469 of file network_gui.cpp.

## Member Function Documentation

## ◆ BuildGUINetworkGameList()

void NetworkGameWindow::BuildGUINetworkGameList | ( |  | ) |
| inlineprotected

Dimension of compatibility icon.

(Re)build the GUI network game list (a.k.a. this->servers) as some major change has occurred. It ensures appropriate filtering and sorting, if both or either one is enabled.

Definition at line 202 of file network_gui.cpp.

References _network_game_list, Textbuf::buf, GUIList< T, P, F >::Filter(), Window::GetWidget(), StringFilter::IsEmpty(), GUIList< T, P, F >::NeedRebuild(), NetworkGameList::next, GUIList< T, P, F >::RebuildDone(), Scrollbar::SetCount(), GUIList< T, P, F >::SetFilterState(), StringFilter::SetFilterTerm(), GUIList< T, P, F >::Sort(), and UpdateListPos().

Referenced by OnEditboxChanged(), and OnPaint().

## ◆ DrawDetails()

void NetworkGameWindow::DrawDetails | ( | const Rect & | r | ) | const
| inline

Definition at line 619 of file network_gui.cpp.

## ◆ DrawServerLine()

void NetworkGameWindow::DrawServerLine | ( | const NetworkGameList * | cur_item,
|  | int | y,
|  | bool | highlight
| ) |  | const
| inlineprotected

Draw a single server line.

Parameters

  cur_item | the server to draw.
  y | from where to draw?
  highlight | does the line need to be highlighted?

Definition at line 353 of file network_gui.cpp.

References _current_text_dir, WidgetDimensions::bevel, TimerGameCalendar::ConvertDateToYMD(), NWidgetBase::current_x, DrawString(), FS_NORMAL, GetCharacterHeight(), Window::GetWidget(), GfxFillRect(), NetworkGameList::info, WidgetDimensions::matrix, NGLS_ONLINE, PC_GREY, Window::resize, SA_CENTER, SA_HOR_CENTER, WidgetDimensions::scaled, SetDParam(), Rect::Shrink(), ResizeInfo::step_height, TD_RTL, Ticks::TICKS_PER_SECOND, NetworkServerGameInfo::use_password, RectPadding::Vertical(), WID_NG_CLIENTS, WID_NG_DATE, WID_NG_INFO, WID_NG_MAPSIZE, WID_NG_NAME, WID_NG_YEARS, and Rect::WithWidth().

Referenced by DrawWidget().

## ◆ DrawWidget()

void NetworkGameWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 531 of file network_gui.cpp.

References DrawServerLine(), Window::DrawSortButtonState(), Scrollbar::GetVisibleRangeIterators(), Window::GetWidget(), GUIList< T, P, F >::IsDescSortOrder(), Window::resize, SBS_DOWN, SBS_UP, GUIList< T, P, F >::SortType(), ResizeInfo::step_height, WID_NG_CLIENTS, WID_NG_DATE, WID_NG_DETAILS, WID_NG_INFO, WID_NG_LASTJOINED, WID_NG_MAPSIZE, WID_NG_MATRIX, WID_NG_NAME, and WID_NG_YEARS.

## ◆ GetHeaderString()

StringID NetworkGameWindow::GetHeaderString | ( |  | ) | const
| inline

Definition at line 606 of file network_gui.cpp.

## ◆ NGameAllowedSorter()

static bool NetworkGameWindow::NGameAllowedSorter | ( | NetworkGameList *const & | a,
|  | NetworkGameList *const & | b
| ) |  |
| inlinestaticprotected

Sort servers by joinability.

If both servers are the same, prefer the non-passworded server first.

Definition at line 303 of file network_gui.cpp.

References NetworkGameInfo::compatible, NetworkGameList::info, NGameClientSorter(), NetworkServerGameInfo::server_revision, NetworkServerGameInfo::use_password, and NetworkGameInfo::version_compatible.

## ◆ NGameCalendarDateSorter()

static bool NetworkGameWindow::NGameCalendarDateSorter | ( | NetworkGameList *const & | a,
|  | NetworkGameList *const & | b
| ) |  |
| inlinestaticprotected

Sort servers by calendar date.

Definition at line 284 of file network_gui.cpp.

References NetworkServerGameInfo::calendar_date, NetworkGameList::info, and NGameClientSorter().

## ◆ NGameClientSorter()

static bool NetworkGameWindow::NGameClientSorter | ( | NetworkGameList *const & | a,
|  | NetworkGameList *const & | b
| ) |  |
| inlinestaticprotected

Sort servers by the amount of clients online on a server.

If the two servers have the same amount, the one with the higher maximum is preferred.

Definition at line 262 of file network_gui.cpp.

References NetworkServerGameInfo::clients_max, NetworkServerGameInfo::clients_on, NetworkGameList::info, and NGameNameSorter().

Referenced by NGameAllowedSorter(), NGameCalendarDateSorter(), NGameMapSizeSorter(), and NGameTicksPlayingSorter().

## ◆ NGameMapSizeSorter()

static bool NetworkGameWindow::NGameMapSizeSorter | ( | NetworkGameList *const & | a,
|  | NetworkGameList *const & | b
| ) |  |
| inlinestaticprotected

Sort servers by map size.

Definition at line 274 of file network_gui.cpp.

References NetworkGameList::info, NetworkServerGameInfo::map_height, NetworkServerGameInfo::map_width, and NGameClientSorter().

## ◆ NGameNameSorter()

static bool NetworkGameWindow::NGameNameSorter | ( | NetworkGameList *const & | a,
|  | NetworkGameList *const & | b
| ) |  |
| inlinestaticprotected

Sort servers by name.

Definition at line 249 of file network_gui.cpp.

References NetworkGameList::connection_string, NetworkGameList::info, NetworkServerGameInfo::server_name, and StrNaturalCompare().

Referenced by NGameClientSorter().

## ◆ NGameSearchFilter()

static bool NetworkGameWindow::NGameSearchFilter | ( | NetworkGameList *const * | item,
|  | StringFilter & | sf
| ) |  |
| inlinestaticprotected

Definition at line 337 of file network_gui.cpp.

## ◆ NGameTicksPlayingSorter()

static bool NetworkGameWindow::NGameTicksPlayingSorter | ( | NetworkGameList *const & | a,
|  | NetworkGameList *const & | b
| ) |  |
| inlinestaticprotected

Sort servers by the number of ticks the game is running.

Definition at line 291 of file network_gui.cpp.

References NetworkGameList::info, NGameClientSorter(), and NetworkServerGameInfo::ticks_playing.

## ◆ OnClick()

void NetworkGameWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 693 of file network_gui.cpp.

References _network_coordinator_client, _settings_client, CloseWindowById(), COMPANY_SPECTATOR, NetworkSettings::connect_to_ip, NetworkGameList::connection_string, CS_ALPHANUMERAL, GUIList< T, P, F >::ForceResort(), ClientNetworkCoordinatorSocketHandler::GetListing(), Scrollbar::GetScrolledItemFromWidget(), Window::GetWidget(), NetworkServerGameInfo::grfconfig, NetworkGameList::info, Window::IsWidgetDisabled(), last_joined, ClientSettings::network, NETWORK_HOSTNAME_PORT_LENGTH, NetworkClientConnectGame(), NetworkQueryServer(), NetworkUDPSearchGame(), OnClick(), QSF_ACCEPT_UNCHANGED, NetworkGameList::refreshing, ScrollToSelectedServer(), server, Window::SetDirty(), SetDParamStr(), GUIList< T, P, F >::SetSortType(), ShowNewGRFSettings(), ShowQueryString(), SortNetworkGameList(), GUIList< T, P, F >::SortType(), GUIList< T, P, F >::ToggleSortOrder(), UpdateListPos(), WC_NETWORK_WINDOW, WID_NG_ADD, WID_NG_CANCEL, WID_NG_CLIENTS, WID_NG_DATE, WID_NG_INFO, WID_NG_JOIN, WID_NG_LASTJOINED, WID_NG_MAPSIZE, WID_NG_MATRIX, WID_NG_NAME, WID_NG_NEWGRF, WID_NG_NEWGRF_MISSING, WID_NG_REFRESH, WID_NG_SEARCH_INTERNET, WID_NG_SEARCH_LAN, WID_NG_START, WID_NG_YEARS, and WN_NETWORK_WINDOW_GAME.

Referenced by OnClick().

## ◆ OnEditboxChanged()

void NetworkGameWindow::OnEditboxChanged | ( | WidgetID | widget | ) |
| inlineoverridevirtual

The text in an editbox has been edited.

Parameters

  widget | The widget of the editbox.

Reimplemented from Window.

Definition at line 827 of file network_gui.cpp.

References _settings_client, Textbuf::buf, BuildGUINetworkGameList(), NetworkSettings::client_name, GUIList< T, P, F >::ForceRebuild(), Window::GetWidget(), ClientSettings::network, ScrollToSelectedServer(), Window::SetDirty(), WID_NG_CLIENT, and WID_NG_FILTER.

## ◆ OnInit()

void NetworkGameWindow::OnInit | ( |  | ) |
| inlineoverridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 474 of file network_gui.cpp.

References GetScaledSpriteSize().

## ◆ OnInvalidateData()

void NetworkGameWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 791 of file network_gui.cpp.

References GUIList< T, P, F >::ForceRebuild(), and Window::SetDirty().

## ◆ OnKeyPress()

EventState NetworkGameWindow::OnKeyPress | ( | char32_t | key,
|  | uint16_t | keycode
| ) |  |
| inlineoverridevirtual

A key has been pressed.

Parameters

  key | the Unicode value of the key.
  keycode | the untranslated key code including shift state.

Returns
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 797 of file network_gui.cpp.

References ES_HANDLED, ES_NOT_HANDLED, Window::GetWidget(), list_pos, NetworkGameListRemoveItem(), ScrollToSelectedServer(), Window::SetDirty(), and Scrollbar::UpdateListPositionOnKeyPress().

## ◆ OnPaint()

void NetworkGameWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 567 of file network_gui.cpp.

References BuildGUINetworkGameList(), NetworkServerGameInfo::clients_max, NetworkServerGameInfo::clients_on, NetworkGameInfo::compatible, Window::DrawWidgets(), Window::GetWidget(), NetworkServerGameInfo::grfconfig, NetworkGameList::info, GUIList< T, P, F >::NeedRebuild(), GUIList< T, P, F >::NeedResort(), NGLS_ONLINE, NetworkGameList::refreshing, Window::ReInit(), server, Window::SetWidgetDisabledState(), Window::SetWidgetLoweredState(), SortNetworkGameList(), NetworkGameList::status, SZSP_NONE, NetworkGameInfo::version_compatible, WID_NG_ADD, WID_NG_JOIN, WID_NG_NEWGRF_MISSING_SEL, WID_NG_NEWGRF_SEL, WID_NG_REFRESH, WID_NG_SEARCH_INTERNET, WID_NG_SEARCH_LAN, and WID_NG_START.

## ◆ OnQueryTextFinished()

void NetworkGameWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 846 of file network_gui.cpp.

References _settings_client, NetworkSettings::connect_to_ip, ClientSettings::network, and NetworkAddServer().

## ◆ OnResize()

void NetworkGameWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 855 of file network_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_NG_MATRIX.

## ◆ ScrollToSelectedServer()

void NetworkGameWindow::ScrollToSelectedServer | ( |  | ) |
| inlineprotected

Scroll the list up or down to the currently selected server.

If the server is below the currently displayed servers, it will scroll down an amount so that the server appears at the bottom. If the server is above the currently displayed servers, it will scroll up so that the server appears at the top.

Definition at line 429 of file network_gui.cpp.

References Scrollbar::ScrollTowards().

Referenced by OnClick(), OnEditboxChanged(), and OnKeyPress().

## ◆ SortNetworkGameList()

void NetworkGameWindow::SortNetworkGameList | ( |  | ) |
| inlineprotected

Sort the server list.

Definition at line 320 of file network_gui.cpp.

References GUIList< T, P, F >::Sort(), and UpdateListPos().

Referenced by OnClick(), and OnPaint().

## ◆ UpdateListPos()

void NetworkGameWindow::UpdateListPos | ( |  | ) |
| inlineprotected

Set this->list_pos to match this->server.

Definition at line 326 of file network_gui.cpp.

Referenced by BuildGUINetworkGameList(), OnClick(), and SortNetworkGameList().

## ◆ UpdateWidgetSize()

void NetworkGameWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 480 of file network_gui.cpp.

References FS_NORMAL, GetCharacterHeight(), GetSpriteSize(), GetStringBoundingBox(), Window::GetWidget(), Window::height, WidgetDimensions::hsep_normal, WidgetDimensions::matrix, MAX_CLIENTS, MAX_COMPANIES, MAX_MAP_SIZE, maxdim(), Window::resize, WidgetDimensions::scaled, SetDParamMaxValue(), Window::SortButtonWidth(), RectPadding::Vertical(), WID_NG_CLIENTS, WID_NG_DATE, WID_NG_INFO, WID_NG_LASTJOINED, WID_NG_LASTJOINED_SPACER, WID_NG_MAPSIZE, WID_NG_MATRIX, WID_NG_NAME, and WID_NG_YEARS.

## Field Documentation

## ◆ blot

Dimension NetworkGameWindow::blot
| protected

Dimension of lock icon.

Definition at line 195 of file network_gui.cpp.

## ◆ filter_editbox

QueryString NetworkGameWindow::filter_editbox
| protected

Editbox for filter on servers.

Definition at line 191 of file network_gui.cpp.

## ◆ filter_funcs

const std::initializer_list< GUIGameServerList::FilterFunction *const > NetworkGameWindow::filter_funcs
| staticprotected

Initial value:
= {
&NGameSearchFilter
}

Definition at line 878 of file network_gui.cpp.

## ◆ last_joined

NetworkGameList* NetworkGameWindow::last_joined
| protected

The last joined server.

Definition at line 186 of file network_gui.cpp.

Referenced by OnClick().

## ◆ last_sorting

Listing NetworkGameWindow::last_sorting = {false, 5}
| staticprotected

Definition at line 868 of file network_gui.cpp.

## ◆ list_pos

ServerListPosition NetworkGameWindow::list_pos
| protected

Position of the selected server.

Definition at line 188 of file network_gui.cpp.

Referenced by OnKeyPress().

## ◆ lock

Dimension NetworkGameWindow::lock
| protected

Definition at line 194 of file network_gui.cpp.

## ◆ name_editbox

QueryString NetworkGameWindow::name_editbox
| protected

Client name editbox.

Definition at line 190 of file network_gui.cpp.

## ◆ refresh_interval

IntervalTimer<TimerWindow> NetworkGameWindow::refresh_interval

Initial value:
= {std::chrono::seconds(30), [this](uint) {
if (!this->searched_internet) return;
_network_coordinator_client.GetListing();
}}
ClientNetworkCoordinatorSocketHandler::GetListing
void GetListing()
Request a listing of all public servers.
Definition network_coordinator.cpp:495
NetworkGameWindow::searched_internet
bool searched_internet
Did we ever press "Search Internet" button?
Definition network_gui.cpp:192
_network_coordinator_client
ClientNetworkCoordinatorSocketHandler _network_coordinator_client
The connection to the Game Coordinator.
Definition network_coordinator.cpp:30

Refresh the online servers on a regular interval.

Definition at line 861 of file network_gui.cpp.

## ◆ searched_internet

bool NetworkGameWindow::searched_internet = false
| protected

Did we ever press "Search Internet" button?

Definition at line 192 of file network_gui.cpp.

## ◆ server

NetworkGameList* NetworkGameWindow::server
| protected

Selected server.

Definition at line 185 of file network_gui.cpp.

Referenced by OnClick(), and OnPaint().

## ◆ servers

GUIGameServerList NetworkGameWindow::servers
| protected

List with game servers.

Definition at line 187 of file network_gui.cpp.

## ◆ sorter_funcs

const std::initializer_list< GUIGameServerList::SortFunction *const > NetworkGameWindow::sorter_funcs
| staticprotected

Initial value:
= {
&NGameNameSorter,
&NGameClientSorter,
&NGameMapSizeSorter,
&NGameCalendarDateSorter,
&NGameTicksPlayingSorter,
&NGameAllowedSorter
}
NetworkGameWindow::NGameClientSorter
static bool NGameClientSorter(NetworkGameList *const &a, NetworkGameList *const &b)
Sort servers by the amount of clients online on a server.
Definition network_gui.cpp:262
NetworkGameWindow::NGameMapSizeSorter
static bool NGameMapSizeSorter(NetworkGameList *const &a, NetworkGameList *const &b)
Sort servers by map size.
Definition network_gui.cpp:274
NetworkGameWindow::NGameAllowedSorter
static bool NGameAllowedSorter(NetworkGameList *const &a, NetworkGameList *const &b)
Sort servers by joinability.
Definition network_gui.cpp:303
NetworkGameWindow::NGameNameSorter
static bool NGameNameSorter(NetworkGameList *const &a, NetworkGameList *const &b)
Sort servers by name.
Definition network_gui.cpp:249
NetworkGameWindow::NGameCalendarDateSorter
static bool NGameCalendarDateSorter(NetworkGameList *const &a, NetworkGameList *const &b)
Sort servers by calendar date.
Definition network_gui.cpp:284
NetworkGameWindow::NGameTicksPlayingSorter
static bool NGameTicksPlayingSorter(NetworkGameList *const &a, NetworkGameList *const &b)
Sort servers by the number of ticks the game is running.
Definition network_gui.cpp:291

Definition at line 869 of file network_gui.cpp.

## ◆ vscroll

Scrollbar* NetworkGameWindow::vscroll
| protected

Vertical scrollbar of the list of servers.

Definition at line 189 of file network_gui.cpp.

The documentation for this class was generated from the following file:

- src/network/network_gui.cpp